/*-----------------------------------------------------------------------*/

proc (10) = MonPol31(beta,delta,fi,gamm,tauy,taupi,omega,chi,D );

  local n1,n2,Aupi,Auy,Api,Ay,Atilde,Btilde,F,A0tilde,A0tilde_1,A,B,upi,uy,
        K,QUUR,n,Q,U,R;

  n1 = 2;
  n2 = 2;

                               /*State space representation*/
  Aupi   = taupi~0~0~0;           /*x(t)=epi(t),ey(t),pi(t),y(t)*/
  Auy    = 0~tauy~0~0;            /*x(t+1)=A*x(t)+b*i(t)+e(t)*/
  Api    = (-delta)~0~1~(-delta*fi);
  Ay     = 0~1~0~1;
  Atilde = Aupi|Auy|Api|Ay;

  Btilde = 0|0|0|(1/gamm);

  F      = -(0~0~chi~omega);

  A0tilde =  (1~0~0       ~0)|
             (0~1~0       ~0)|
             (0~0~beta    ~0)|
             (0~0~(1/gamm)~1);

  A0tilde_1 = inv(A0tilde);
  A = A0tilde_1*Atilde;
  B = A0tilde_1*Btilde;
  upi = inv(A0tilde)*(1|0|0|0);    /*price shock*/
  uy  = inv(A0tilde)*(0|(-1)|0|0); /*positive demand shock*/


  K = (0~0~1~0~0)|           /*[pi(t),y(t),i(t)]= K*[x1(t),x2{t),u(t)]*/
      (0~0~0~1~0)|
      (0~0~0~0~1);
  QUUR = K'D*K;
  n = n1 + n2;
  Q    = QUUR[1:n,1:n];
  U    = QUUR[1:n,n+1:cols(QUUR)];
  R    = QUUR[n+1:cols(QUUR),n+1:cols(QUUR)];


retp(A,B,Q,U,R,F,n1,n2,upi,uy);

endp;
/*------------------------------------------------------------------------------*/

